%
% T_CONSTRAINT: checks to see if a flux violates the thermoynamic
%   constraint in terms of the matroid formalism.
%
% INPUTS: J - putative flux vector.
%         C - matrix of cycles
%         j_obj - placeholder not used in this function
%
% OUTPUTS: con_ie - vector of inequality constraints.
%          con_eq - vector of equality constraints
%
function [con_ie,con_eq] = T_CONSTRAINT(J,C,j_obj);

n_int = length(C(:,1));
con_ie = abs(sign(C')*sign(J(1:n_int))) - sum(C~=0)' + 0.5;
con_eq = [];
