function [C,Ceq] = gfe_cons(g,J1,J2,Srx,dir1,dir2,go,kT,L);

[m,n] = size(Srx);
g1 = g(1:m);
g2 = g((m+1):(2*m));
c1 = exp((g1-go')./kT); 
c2 = exp((g2-go')./kT); 

dG1 = Srx'*g1;
dG2 = Srx'*g2;
% ANT transporter dependence on membrane potential:
dG1(39) = dG1(39) + go(46);
dG2(39) = dG2(39) + go(46);
% pH dependence on Pi transport:
dG1(40) = dG1(40) + kT*log(c1(46));
dG2(40) = dG2(40) + kT*log(c2(46));

% indices of concentrations that are constrained to be
%   between 1 um and 10 mM:
ic = [(1:15) (17:21) (23:27) (29:45) (47:m)];

% Inequality constraints:
C = [(c1(ic) - 0.01)*1e2    % max. allowable concentration
     (c2(ic) - 0.01)*1e2    % 
    -(c1(ic) - 1e-7)*1e6    % min. allowable concentration
    -(c2(ic) - 1e-7)*1e6    %
     dG1.*dir1 + 0.01.*abs(J1(1:n)) % 2nd law constraint
     dG2.*dir2 + 0.01.*abs(J2(1:n)) % 2nd law constraint
     (abs(dG1) - 30 )
     (abs(dG2) - 30 )
     
     -(c1(11) - 1e-4)*1e4
     -(c2(11) - 1e-4)*1e4
     -(c1(27) - 1e-4)*1e4
     -(c2(27) - 1e-4)*1e4
     -(c1(11)/c1(10) - 0.1)
     -(c2(11)/c2(10) - 0.1)
     -(c1(27)/c1(26) - 0.1)
     -(c2(27)/c2(26) - 0.1)

% ndk near equilibrium:
       abs(dG1(16)) - 0.1
       abs(dG2(16)) - 0.1
       abs(dG1(27)) - 0.1
       abs(dG2(27)) - 0.1   
     ] ;

% Equality constraints:
Ceq = [L'*(c2 - c1)*1e2
       (c1(1) - 5e-3)*1e2       % fixed glucose
       (c2(1) - 5e-3)*1e2       % fixed glucose 
       (c1(28) - 25e-3)*1e2     % fixed CO2tot
       (c2(28) - 25e-3)*1e2     % fixed CO2tot
       (c1(48) - 2.7e-5)*1e5    % fixed O2 conc.
       (c2(48) - 2.7e-5)*1e5    % fixed O2 conc.
       g1(16) - go(16)          % fixed water conc.
       g2(16) - go(16)          % fixed water conc.
       g1(22) - go(22)          % fixed glycogen activity
       g2(22) - go(22)          % fixed glycogen activity    
   ];
 
   